Module TableInformation
    Public Table_Information(12, 20) As String


    'Database password is scandatathingy



    Public Enum TP  'Table Parameter
        Table_Name = 1
        Start_Position = 2
        Element_Size = 3
        Factor = 4
        Units = 5
        Column_Count = 6
        Row_Count = 7
        Row_Header_Step = 8
        Row_Header_Start = 9
        AllowNegative = 10
        Table_Description = 11
        Table_Column_Headers = 12
        Table_Row_Headers = 13
    End Enum

    Public Enum RT  'RetrieveType
        ret_FlashCRC = 1
        ret_OSIDLoc = 2
        ret_YearModel = 3
        ret_MBTSLoc = 4
        ret_GFSLoc = 5
        ret_MAFLoc = 6
        ret_VELoc = 7
        ret_VERowCount = 8
    End Enum

    Public Function Get_VE_Table_Info(ByVal OSID As String) As Boolean

        Dim tmptableLocation As String = GetParameters(OSID, RT.ret_VELoc)
        If tmptableLocation = "" Then
            Multiplier = ""
            Row_Count = ""
            Column_Count = ""
            Table_Location = ""
            Return False
        Else
            Multiplier = 0.0002441406
            Row_Count = GetParameters(OSID, RT.ret_VERowCount)
            Column_Count = 17
            Table_Location = tmptableLocation
            Return True
        End If

    End Function
    Public Function Get_MAF_Table_Info(ByVal OSID As String) As Boolean

        Dim tmptableLocation As String = GetParameters(OSID, RT.ret_MAFLoc)
        If tmptableLocation = "" Then
            Multiplier = ""
            Row_Count = ""
            Column_Count = ""
            Table_Location = ""
            Return False
        Else
            Multiplier = 0.0078125
            Row_Count = 81
            Column_Count = 1
            Table_Location = tmptableLocation
            Return True
        End If

    End Function
    Public Function Get_GFS_Table_Info(ByVal OSID As String) As Boolean

        Dim tmptableLocation As String = GetParameters(OSID, RT.ret_GFSLoc)
        If tmptableLocation = "" Then
            Multiplier = ""
            Row_Count = ""
            Column_Count = ""
            Table_Location = ""
            Return False
        Else
            Multiplier = 0.02197265625
            Row_Count = 16
            Column_Count = 21
            Table_Location = tmptableLocation
            Return True
        End If

    End Function

    Public Function GetTables(ByVal OSID As Long) As Boolean

        ReDim Table_Information(15, 40)

        Select Case OSID
            Case 9352809

                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "75712"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "PE AFR"
                Table_Information(9, 1) = "0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100"
                Table_Information(11, 1) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings."
                Table_Information(12, 1) = "PE AFR Add"
                Table_Information(13, 1) = "0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100"

                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "75CAA"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "This is the base Enleanment Fraction vs. the maximum TPS delta seen during this enable period."
                Table_Information(12, 2) = "DE A/F Multiplier"
                Table_Information(13, 2) = "0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100"

                Table_Information(1, 3) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 3) = "75CD4"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "31"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enleanment."
                Table_Information(12, 3) = "DE A/F Multiplier"
                Table_Information(13, 3) = "0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30"

                Table_Information(1, 4) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 4) = "74DBE"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "65"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(12, 4) = "AE A/F Miltiplier"
                Table_Information(13, 4) = "0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64"

                Table_Information(1, 5) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 5) = "78AD4"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "19"
                Table_Information(7, 5) = "16"
                Table_Information(8, 5) = "18"
                Table_Information(9, 5) = "-40"
                Table_Information(11, 5) = "TPS vs ECT - This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance."
                Table_Information(12, 5) = "-40,-22,-4,14,32,50,68,86,104,122,140,158,176,194,212,230,248,266,284"
                Table_Information(13, 5) = "0.08,0.12,0.16,0.20,0.24,0.28,0.32,0.36,0.40,0.44,0.48,0.52,0.56,0.68,0.80,0.92"

                Table_Information(1, 6) = "Knock Fast Attack Base Retard vs. RPM"
                Table_Information(2, 6) = "7A24A"
                Table_Information(3, 6) = "2"
                Table_Information(4, 6) = "0.02197265625"
                Table_Information(6, 6) = "1"
                Table_Information(7, 6) = "21"
                Table_Information(8, 6) = "400"
                Table_Information(9, 6) = "0"
                Table_Information(11, 6) = "This is the amount of timing that is subtracted in proportion to each knock detected. It is multiplied by the Temperature and Baro gain factors. The higher this number is the more aggressive Knock Retard will be."
                Table_Information(12, 6) = "Spark Attack"
                Table_Information(13, 6) = "0,400,800,1200,1600,2000,2400,2800,3200,3600,4000,4400,4800,5200,5600,6000,6400,6800,7200,7600,8000"

                Table_Information(1, 7) = "TCC Apply 3rd Cruise"
                Table_Information(2, 7) = "7BE52"
                Table_Information(3, 7) = "2"
                Table_Information(4, 7) = "0.00390625"
                Table_Information(5, 7) = "MPH"
                Table_Information(6, 7) = "1"
                Table_Information(7, 7) = "17"
                Table_Information(12, 7) = "MPH"
                Table_Information(13, 7) = "0,6,12,18,24,30,36,42,48,54,60,66,72,78,84,90,96,102"

                Table_Information(1, 8) = "TCC Apply 4th Cruise"
                Table_Information(2, 8) = "7BE74"
                Table_Information(3, 8) = "2"
                Table_Information(4, 8) = "0.00390625"
                Table_Information(5, 8) = "MPH"
                Table_Information(6, 8) = "1"
                Table_Information(7, 8) = "17"
                Table_Information(13, 8) = "0,6,12,18,24,30,36,42,48,54,60,66,72,78,84,90,96,102"

                Table_Information(1, 9) = "TCC Release 3rd Cruise"
                Table_Information(2, 9) = "7BE96"
                Table_Information(3, 9) = "2"
                Table_Information(4, 9) = "0.00390625"
                Table_Information(5, 9) = "MPH"
                Table_Information(6, 9) = "1"
                Table_Information(7, 9) = "17"
                Table_Information(13, 9) = "0,6,12,18,24,30,36,42,48,54,60,66,72,78,84,90,96,102"

                Table_Information(1, 10) = "TCC Release 4th Cruise"
                Table_Information(2, 10) = "7BEB8"
                Table_Information(3, 10) = "2"
                Table_Information(4, 10) = "0.00390625"
                Table_Information(5, 10) = "MPH"
                Table_Information(6, 10) = "1"
                Table_Information(7, 10) = "17"
                Table_Information(13, 10) = "0,6,12,18,24,30,36,42,48,54,60,66,72,78,84,90,96,102"

                Table_Information(1, 11) = "Abuse Mode Duration vs. Trans Temp"
                Table_Information(2, 11) = "7B53A"
                Table_Information(3, 11) = "2"
                Table_Information(4, 11) = "0.00625"
                Table_Information(5, 11) = "Seconds"
                Table_Information(6, 11) = "2"
                Table_Information(7, 11) = "17"
                Table_Information(12, 11) = "Seconds,Seconds"
                Table_Information(13, 11) = "-40,-18,3,25,46,68,89,111,133,154,177,198,219,241,262,284,305"

                Table_Information(1, 12) = "FMC vs. CLP vs. Temp - Positive"
                Table_Information(2, 12) = "7F8A4"
                Table_Information(3, 12) = "1"
                Table_Information(4, 12) = "4.8823529411764705882352941176471"
                Table_Information(5, 12) = "Milliamps"
                Table_Information(6, 12) = "17"
                Table_Information(7, 12) = "18"
                Table_Information(11, 12) = "Force Motor Current vs. Commanded Line Pressure vs. Temp - Positive"
                Table_Information(12, 12) = "-40,-18,4,26,48,70,92,114,136,158,180,202,224,246,268,290,312"
                Table_Information(13, 12) = "0,6,12,18,24,30,36,42,48,54,60,66,72,78,84,90,96,100"

                Table_Information(1, 13) = "FMC vs. CLP vs. Temp - Negative"
                Table_Information(2, 13) = "7F9D6"
                Table_Information(3, 13) = "1"
                Table_Information(4, 13) = "4.8823529411764705882352941176471"
                Table_Information(5, 13) = "Milliamps"
                Table_Information(6, 13) = "17"
                Table_Information(7, 13) = "18"
                Table_Information(11, 13) = "Force Motor Current vs. Commanded Line Pressure vs. Temp - Negative"
                Table_Information(12, 13) = "-40,-18,4,26,48,70,92,114,136,158,180,202,224,246,268,290,312"
                Table_Information(13, 13) = "0,6,12,18,24,30,36,42,48,54,60,66,72,78,84,90,96,100"

                Table_Information(1, 14) = "Reverse_Gear_Ratio"
                Table_Information(2, 14) = "7CD14"
                Table_Information(3, 14) = "2"
                Table_Information(4, 14) = "0.0002441406"
                Table_Information(5, 14) = "Ratio"
                Table_Information(6, 14) = "1"
                Table_Information(7, 14) = "1"

                Table_Information(1, 15) = "First_Gear_Ratio"
                Table_Information(2, 15) = "7CD10"
                Table_Information(3, 15) = "2"
                Table_Information(4, 15) = "0.0002441406"
                Table_Information(5, 15) = "Ratio"
                Table_Information(6, 15) = "1"
                Table_Information(7, 15) = "1"

                Table_Information(1, 16) = "Second_Gear_Ratio"
                Table_Information(2, 16) = "7CD12"
                Table_Information(3, 16) = "2"
                Table_Information(4, 16) = "0.0002441406"
                Table_Information(5, 16) = "Ratio"
                Table_Information(6, 16) = "1"
                Table_Information(7, 16) = "1"

                Table_Information(1, 17) = "Third_Gear_Ratio"
                Table_Information(2, 17) = "7CDCE"
                Table_Information(3, 17) = "2"
                Table_Information(4, 17) = "0.0002441406"
                Table_Information(5, 17) = "Ratio"
                Table_Information(6, 17) = "1"
                Table_Information(7, 17) = "1"

                Table_Information(1, 18) = "Fourth_Gear_Ratio"
                Table_Information(2, 18) = "7CDD0"
                Table_Information(3, 18) = "2"
                Table_Information(4, 18) = "0.0002441406"
                Table_Information(5, 18) = "Ratio"
                Table_Information(6, 18) = "1"
                Table_Information(7, 18) = "1"

                Table_Information(1, 19) = "Startup A/F Enable Time vs ECT"
                Table_Information(2, 19) = "75760"
                Table_Information(3, 19) = "2"
                Table_Information(4, 19) = "0.00625"
                Table_Information(6, 19) = "3"
                Table_Information(7, 19) = "19"
                Table_Information(11, 19) = "These tables control the delay before Startup AFR Correction is enabled"
                Table_Information(12, 19) = "P/N,In Gear,Cold Start"
                Table_Information(13, 19) = "-40,-22,-4,14,32,50,68,86,104,122,140,158,176,194,212,230,248,266,284"

                Table_Information(1, 20) = "Decay vs Startup ECT vs. RPM - In Gear"
                Table_Information(2, 20) = "75A56"
                Table_Information(3, 20) = "2"
                Table_Information(4, 20) = "0.00003039501757"
                Table_Information(6, 20) = "7"
                Table_Information(7, 20) = "10"
                Table_Information(12, 20) = "0,800,1600,2400,3200,4000,4800"
                Table_Information(13, 20) = "-40,-4,32,68,104,140,176,212,248,284"

                Table_Information(1, 21) = "Decay vs Startup ECT vs. RPM - P/N"
                Table_Information(2, 21) = "759CA"
                Table_Information(3, 21) = "2"
                Table_Information(4, 21) = "0.00003039501757"
                Table_Information(6, 21) = "7"
                Table_Information(7, 21) = "10"
                Table_Information(12, 21) = "0,800,1600,2400,3200,4000,4800"
                Table_Information(13, 21) = "-40,-4,32,68,104,140,176,212,248,284"

                Table_Information(1, 22) = "AE Modifier vs. ECT vs. ERT - P/N"
                Table_Information(2, 22) = "74E40"
                Table_Information(3, 22) = "2"
                Table_Information(4, 22) = "0.00006103515625"
                Table_Information(6, 22) = "14"
                Table_Information(7, 22) = "10"
                Table_Information(11, 22) = "Startup (vs. Engine Run Time) AE modifier in Gear"
                Table_Information(12, 22) = "0,4,8,12,16,20,24,28,32,36,40,44,48,52"
                Table_Information(13, 22) = "-40,-4,32,68,104,140,176,212,248,284"

                Table_Information(1, 23) = "AE Modifier vs. ECT vs. ERT - In Gear"
                Table_Information(2, 23) = "74F58"
                Table_Information(3, 23) = "2"
                Table_Information(4, 23) = "0.00006103515625"
                Table_Information(6, 23) = "14"
                Table_Information(7, 23) = "10"
                Table_Information(11, 23) = "Startup (vs. Engine Run Time) AE modifier in Park or Neutral"
                Table_Information(12, 23) = "0,4,8,12,16,20,24,28,32,36,40,44,48,52"
                Table_Information(13, 23) = "-40,-4,32,68,104,140,176,212,248,284"

                Table_Information(1, 24) = "Startup AE Modifier vs. AFR Correction"
                Table_Information(2, 24) = "75086"
                Table_Information(3, 24) = "2"
                Table_Information(4, 24) = "0.00006103515625"
                Table_Information(6, 24) = "1"
                Table_Information(7, 24) = "6"
                Table_Information(11, 24) = "Startup AE modifier versus the startup AFR correction factor"
                Table_Information(12, 24) = "Multiplier"
                Table_Information(13, 24) = "0 AFR,1AFR,2AFR,3AFR,4AFR,5AFR"

                Table_Information(1, 25) = "Startup AE Modifier vs. TPS"
                Table_Information(2, 25) = "75070"
                Table_Information(3, 25) = "2"
                Table_Information(4, 25) = "0.00006103515625"
                Table_Information(6, 25) = "1"
                Table_Information(7, 25) = "11"
                Table_Information(11, 25) = "Additional TPS modifier for startup conditions."
                Table_Information(12, 25) = "Multiplier"
                Table_Information(13, 25) = "0,5,10,15,20,25,30,35,40,45,50"

                Table_Information(1, 26) = "AE Modifier vs. Baro"
                Table_Information(2, 26) = "74D6E"
                Table_Information(3, 26) = "2"
                Table_Information(4, 26) = "0.000244140625"
                Table_Information(6, 26) = "1"
                Table_Information(7, 26) = "10"
                Table_Information(11, 26) = "Multiplier vs. Barometric Pressure"
                Table_Information(12, 26) = "Multiplier"
                Table_Information(13, 26) = "60 kPa,65 kPa,70 kPa,75 kPa,80 kPa,85 kPa,90 kPa,95 kPa,100 kPa,105 kPa"

                Table_Information(1, 27) = "TPS Filter Coefficient"
                Table_Information(2, 27) = "74D6A"
                Table_Information(3, 27) = "2"
                Table_Information(4, 27) = "0.000030517578125"
                Table_Information(6, 27) = "1"
                Table_Information(7, 27) = "1"
                Table_Information(11, 27) = "Lag filter coefficient for TPS filter (if enabled)."
                Table_Information(13, 27) = "TPS Filter"

                Table_Information(1, 28) = "Disable Ref Count Limit"
                Table_Information(2, 28) = "74D6C"
                Table_Information(3, 28) = "2"
                Table_Information(4, 28) = "1"
                Table_Information(6, 28) = "1"
                Table_Information(7, 28) = "1"
                Table_Information(11, 28) = "Ref Count Limit to disable AE"
                Table_Information(13, 28) = "Limit"

                Table_Information(1, 29) = "Enable TPS Delta vs. ECT"
                Table_Information(2, 29) = "74D1E"
                Table_Information(3, 29) = "4"
                Table_Information(4, 29) = ".02"
                Table_Information(6, 29) = "1"
                Table_Information(7, 29) = "19"
                Table_Information(11, 29) = "If the positive change in TPS exceeds this value the AE will be enabled."
                Table_Information(12, 29) = "TPS% Delta"
                Table_Information(13, 29) = "-40,-22,-4,14,32,50,68,86,104,122,140,158,176,194,212,230,248,266,284"

                Table_Information(1, 30) = "WOT Disables AE"
                Table_Information(2, 30) = "74D17"
                Table_Information(3, 30) = "1"
                Table_Information(4, 30) = "1"
                Table_Information(6, 30) = "1"
                Table_Information(7, 30) = "1"
                Table_Information(11, 30) = "If 01 then WOT PE mode will disable AE, if 00 then WOT PE mode will not diable AE"
                Table_Information(12, 30) = "Yes"
                Table_Information(13, 30) = "Disable AE"

                Table_Information(1, 31) = "Use Filtered TPS"
                Table_Information(2, 31) = "74D16"
                Table_Information(3, 31) = "1"
                Table_Information(4, 31) = "1"
                Table_Information(6, 31) = "1"
                Table_Information(7, 31) = "1"
                Table_Information(11, 31) = "This switch controls if the VCM uses a filtered TPS delta or an unfiltered value, for the AE calculations"
                Table_Information(12, 31) = "On"
                Table_Information(13, 31) = "Filtered TPS"

                Table_Information(1, 32) = "Disable TPS Closing Delta"
                Table_Information(2, 32) = "74D18"
                Table_Information(3, 32) = "4"
                Table_Information(4, 32) = "0.01953125"
                Table_Information(6, 32) = "1"
                Table_Information(7, 32) = "1"
                Table_Information(11, 32) = "If the TPS delta is below this value then AE will be disabled"
                Table_Information(13, 32) = "TPS Delta"

                Table_Information(1, 33) = "DE Modifier vs. ECT vs. Gear"
                Table_Information(2, 33) = "75D12"
                Table_Information(3, 33) = "2"
                Table_Information(4, 33) = "0.00006103515625"
                Table_Information(6, 33) = "2"
                Table_Information(7, 33) = "10"
                Table_Information(11, 33) = "Multiplier vs. Transmission in gear or Park/Neutral"
                Table_Information(12, 33) = "P/N, In Gear"
                Table_Information(13, 33) = "-40,-4,32,68,104,140,176,212,248,284"

                Table_Information(1, 34) = "DE Modifier vs. Vacuum"
                Table_Information(2, 34) = "75D3A"
                Table_Information(3, 34) = "2"
                Table_Information(4, 34) = "0.00006103515625"
                Table_Information(6, 34) = "1"
                Table_Information(7, 34) = "7"
                Table_Information(11, 34) = "Multiplier vs. manifold vacuum"
                Table_Information(12, 34) = "Multiplier"
                Table_Information(13, 34) = "0 kPa,10 kPa,20 kPa,30 kPa,40 kPa,50 kPa,60 kPa"

                Table_Information(1, 35) = "Catalytic Converter Over Temp A/F Ratio"
                Table_Information(2, 35) = "7573E"
                Table_Information(3, 35) = "2"
                Table_Information(4, 35) = "0.0009765625"
                Table_Information(6, 35) = "1"
                Table_Information(7, 35) = "17"
                Table_Information(11, 35) = "The VCM contains mechanisms to estimate the catalytic converter temperature and provide additional fuel enrichment to decrease exhaust oxygen content if over temperature conditions are detected."
                Table_Information(12, 35) = "COT Min AFR"
                Table_Information(13, 35) = "0.00,1.06,2.12,3.18,4.24,5.30,6.36,7.42,8.48,9.54,10.60,11.66,12.72,13.78,14.84,15.90,16.96"

            Case 9372327
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "754bc"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(11, 1) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings."
                Table_Information(1, 2) = "Decel_Enlean_vs_TPS"
                Table_Information(2, 2) = "75AB2"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "This is the base Enleanment Fraction vs. the maximum TPS delta seen during this enable period. "
                Table_Information(1, 3) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 3) = "74b64"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "65"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 4) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 4) = "75adc"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "31"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enleanment."
                Table_Information(1, 5) = "Attack Base Retard vs. RPM"
                Table_Information(2, 5) = "7A31A"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "1"
                Table_Information(7, 5) = "21"
                Table_Information(8, 5) = "400"
                Table_Information(9, 5) = "0"
                Table_Information(11, 5) = "This is the amount of timing that is subtracted in proportion to each knock detected. It is multiplied by the Temperature and Baro gain factors. The higher this number is the more aggressive Knock Retard will be"
            Case 9384050
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "754FC"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(1, 2) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 2) = "7938C"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.02197265625"
                Table_Information(6, 2) = "19"
                Table_Information(7, 2) = "16"
                Table_Information(8, 2) = "18"
                Table_Information(9, 2) = "-40"
                Table_Information(10, 2) = "True"
                Table_Information(11, 2) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance. "
                Table_Information(1, 3) = "Decel Enlean vs TPS"
                Table_Information(2, 3) = "75C74"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "21"
                Table_Information(8, 3) = "5"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance. "
                Table_Information(1, 4) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 4) = "74BA4"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "65"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 5) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 5) = "75C9E"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.00006103515625"
                Table_Information(6, 5) = "1"
                Table_Information(7, 5) = "31"
                Table_Information(8, 5) = "1"
                Table_Information(9, 5) = "0"
                Table_Information(11, 5) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enleanment."
                Table_Information(1, 6) = "Attack Base Retard vs. RPM"
                Table_Information(2, 6) = "7AE96"
                Table_Information(3, 6) = "2"
                Table_Information(4, 6) = "0.02197265625"
                Table_Information(6, 6) = "1"
                Table_Information(7, 6) = "21"
                Table_Information(8, 6) = "400"
                Table_Information(9, 6) = "0"
                Table_Information(10, 6) = "True"
                Table_Information(11, 6) = "This is the amount of timing that is subtracted in proportion to each knock detected. It is multiplied by the Temperature and Baro gain factors. The higher this number is the more aggressive Knock Retard will be"
            Case 12226107
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "755C6"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "75DD4"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(1, 3) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 3) = "75DFE"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "31"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enleanment."
                Table_Information(1, 4) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 4) = "74912"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "65"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 5) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 5) = "79470"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "16"
                Table_Information(7, 5) = "19"
                Table_Information(8, 5) = "18"
                Table_Information(9, 5) = "-40"
                Table_Information(10, 5) = "True"
                Table_Information(11, 5) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance. "
                Table_Information(1, 6) = "Attack Base Retard vs. RPM"
                Table_Information(2, 6) = "7AF68"
                Table_Information(3, 6) = "2"
                Table_Information(4, 6) = "0.02197265625"
                Table_Information(6, 6) = "1"
                Table_Information(7, 6) = "21"
                Table_Information(8, 6) = "400"
                Table_Information(9, 6) = "0"
                Table_Information(11, 6) = "This is the amount of timing that is subtracted in proportion to each knock detected. It is multiplied by the Temperature and Baro gain factors. The higher this number is the more aggressive Knock Retard will be"
            Case 12223462
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "75416"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "75C24"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(1, 3) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 3) = "74762"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "65"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 4) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 4) = "75C4E"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "31"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enleanment."
                Table_Information(1, 5) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 5) = "792D6"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "15"
                Table_Information(7, 5) = "18"
                Table_Information(8, 5) = "18"
                Table_Information(9, 5) = "-40"
                Table_Information(10, 5) = "True"
                Table_Information(11, 5) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance. "
                Table_Information(1, 6) = "Attack Base Retard vs. RPM"
                Table_Information(2, 6) = "7ADCE"
                Table_Information(3, 6) = "2"
                Table_Information(4, 6) = "0.02197265625"
                Table_Information(6, 6) = "1"
                Table_Information(7, 6) = "21"
                Table_Information(8, 6) = "400"
                Table_Information(9, 6) = "0"
                Table_Information(11, 6) = "This is the amount of timing that is subtracted in proportion to each knock detected. It is multiplied by the Temperature and Baro gain factors. The higher this number is the more aggressive Knock Retard will be"
            Case 12580151
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "74ec8"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "756D6"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "20"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(1, 3) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 3) = "74214"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "65"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 4) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 4) = "75700"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "31"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enrichment."
                Table_Information(1, 5) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 5) = "78E36"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "15"
                Table_Information(7, 5) = "18"
                Table_Information(8, 5) = "18"
                Table_Information(9, 5) = "-40"
                Table_Information(10, 5) = "True"
                Table_Information(11, 5) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance. "
                Table_Information(1, 6) = "Attack Base Retard vs. RPM"
                Table_Information(2, 6) = "7A92E"
                Table_Information(3, 6) = "2"
                Table_Information(4, 6) = "0.02197265625"
                Table_Information(6, 6) = "1"
                Table_Information(7, 6) = "21"
                Table_Information(8, 6) = "400"
                Table_Information(9, 6) = "0"
                Table_Information(11, 6) = "This is the amount of timing that is subtracted in proportion to each knock detected. It is multiplied by the Temperature and Baro gain factors. The higher this number is the more aggressive Knock Retard will be"
            Case 12584056
                Table_Information(1, 1) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 1) = "EE7C0"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.00006103515625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "65"
                Table_Information(8, 1) = "1"
                Table_Information(9, 1) = "0"
                Table_Information(11, 1) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 2) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 2) = "EFCC4"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "31"
                Table_Information(8, 2) = "1"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enrichment."
                Table_Information(1, 3) = "Decel Enlean vs TPS"
                Table_Information(2, 3) = "EFC9A"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "20"
                Table_Information(8, 3) = "5"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "This is the base Enleanment Fraction vs. the maximum TPS delta seen during this enable period."
                Table_Information(1, 4) = "Accel Enrichment vs TPS"
                Table_Information(2, 4) = "EE796"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "21"
                Table_Information(8, 4) = "5"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "This is the base Enrichment Fraction vs. the maximum TPS delta seen during this enable period"
                Table_Information(1, 5) = "AE Modifier vs. Speed"
                Table_Information(2, 5) = "EE784"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.00006103515625"
                Table_Information(6, 5) = "1"
                Table_Information(7, 5) = "9"
                Table_Information(8, 5) = "8"
                Table_Information(9, 5) = "0"
                Table_Information(11, 5) = "This is the AE Multiplier vs. Vehicle Speed "
            Case 16252965
                Table_Information(1, 1) = "Decel Enlean vs TPS"
                Table_Information(2, 1) = "7823E"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.00006103515625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(1, 2) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 2) = "77626"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "65"
                Table_Information(8, 2) = "1"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 3) = "PE A/F vs TPS"
                Table_Information(2, 3) = "77E32"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.0009765625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "21"
                Table_Information(8, 3) = "5"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings."
                Table_Information(1, 4) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 4) = "78268"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "31"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enrichment."
                Table_Information(1, 5) = "ECT Spark Advance Modifier"
                Table_Information(2, 5) = "79d5e"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "19"
                Table_Information(7, 5) = "16"
                Table_Information(8, 5) = "18"
                Table_Information(9, 5) = "-40"
                Table_Information(10, 5) = "True"
                Table_Information(11, 5) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance. "
            Case 12223447
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "75416"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "75C24"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "This is the base Enleanment Fraction vs. the maximum TPS delta seen during this enable period."
                Table_Information(1, 3) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 3) = "75C4E"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "31"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(1, 4) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 4) = "74762"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "65"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 5) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 5) = "792D6"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "19"
                Table_Information(7, 5) = "16"
                Table_Information(8, 5) = "18"
                Table_Information(9, 5) = "-40"
                Table_Information(10, 5) = "True"
                Table_Information(11, 5) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance."
            Case 9352682
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "75712"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(11, 1) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings."
                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "75CAA"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "This is the base Enleanment Fraction vs. the maximum TPS delta seen during this enable period."
                Table_Information(1, 3) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 3) = "75CD4"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "31"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enleanment."
                Table_Information(1, 4) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 4) = "74DBE"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "65"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(1, 5) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 5) = "78AD4"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.02197265625"
                Table_Information(6, 5) = "19"
                Table_Information(7, 5) = "16"
                Table_Information(8, 5) = "4"
                Table_Information(9, 5) = "8"
                Table_Information(10, 5) = "True"
                Table_Information(11, 5) = "This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance."
                Table_Information(1, 6) = "Knock Fast Attack Base Retard vs. RPM"
                Table_Information(2, 6) = "7A24A"
                Table_Information(3, 6) = "2"
                Table_Information(4, 6) = "0.02197265625"
                Table_Information(6, 6) = "1"
                Table_Information(7, 6) = "21"
                Table_Information(8, 6) = "400"
                Table_Information(9, 6) = "0"
                Table_Information(11, 6) = "This is the amount of timing that is subtracted in proportion to each knock detected. It is multiplied by the Temperature and Baro gain factors. The higher this number is the more aggressive Knock Retard will be."
            Case 12586824
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "755C6"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(11, 1) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings."
                Table_Information(1, 2) = "Test - Accel Enrichment vs Ref Counts"
                Table_Information(2, 2) = "74912"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "65"
                Table_Information(8, 2) = "1"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
            Case 12201465
                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "755D2"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(11, 1) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings."
                Table_Information(1, 2) = "Test - Accel Enrichment vs Ref Counts"
                Table_Information(2, 2) = "74C7A"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "65"
                Table_Information(8, 2) = "1"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."

            Case 12583374

                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "74EC8"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(11, 1) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings"
                Table_Information(12, 1) = "A/E Multiplier"
                Table_Information(13, 1) = "0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100"

                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "756D6"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"   'Step
                Table_Information(9, 2) = "0"   'Start
                Table_Information(11, 2) = "This is the base Enleanment Fraction vs. the maximum TPS delta seen during this enable period."
                Table_Information(12, 2) = "Multiplier"
                Table_Information(13, 2) = "0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100"

                Table_Information(1, 3) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 3) = "75700"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "31"
                Table_Information(8, 3) = "1"   'Step
                Table_Information(9, 3) = "0"   'Start
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enleanment."
                Table_Information(13, 3) = "0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30"

                Table_Information(1, 4) = "Engine Coolant Temp Spark Modifier"
                Table_Information(2, 4) = "78E36"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.02197265625"
                Table_Information(6, 4) = "19"
                Table_Information(7, 4) = "16"
                Table_Information(10, 4) = "True"
                Table_Information(11, 4) = "TPS vs ECT - This table is used to modify spark advance based on engine coolant temperature. It adds to the current spark advance."
                Table_Information(12, 4) = "-40,-22,-4,14,32,50,68,86,104,122,140,158,176,194,212,230,248,266,284"
                Table_Information(13, 4) = "0.08,0.12,0.16,0.20,0.24,0.28,0.32,0.36,0.40,0.44,0.48,0.52,0.56,0.68,0.80,0.92"

                Table_Information(1, 5) = "Abuse Mode Duration vs. Trans Temp"
                Table_Information(2, 5) = "7BB1C"
                Table_Information(3, 5) = "2"
                Table_Information(4, 5) = "0.00625"
                Table_Information(6, 5) = "2"
                Table_Information(7, 5) = "17"
                Table_Information(8, 5) = "22"   'Step
                Table_Information(9, 5) = "-40"   'Start
                Table_Information(12, 5) = "Seconds,Seconds"
                Table_Information(13, 5) = "-40,-18,3,25,46,68,89,111,133,154,177,198,219,241,262,284,305"

                Table_Information(1, 6) = "Startup A/F Enable Time vs ECT"
                Table_Information(2, 6) = "74F16"
                Table_Information(3, 6) = "2"
                Table_Information(4, 6) = "0.00625"
                Table_Information(6, 6) = "3"
                Table_Information(7, 6) = "19"
                Table_Information(8, 6) = "18"   'Step
                Table_Information(9, 6) = "-40"   'Start
                Table_Information(11, 6) = "These tables control the delay before Startup AFR Correction is enabled"
                Table_Information(12, 6) = "P/N,In Gear,Cold Start"
                Table_Information(13, 6) = "-40,-22,-4,14,32,50,68,86,104,122,140,158,176,194,212,230,248,266,284"

                Table_Information(1, 7) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 7) = "74214"
                Table_Information(3, 7) = "2"
                Table_Information(4, 7) = "0.00006103515625"
                Table_Information(6, 7) = "1"
                Table_Information(7, 7) = "65"
                Table_Information(8, 7) = "1"   'Step
                Table_Information(9, 7) = "0"   'Start
                Table_Information(11, 7) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."
                Table_Information(12, 7) = "AE A/F Miltiplier"
                Table_Information(13, 7) = "0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64"

                Table_Information(1, 8) = "AE Modifier vs. ECT vs. ERT - P/N"
                Table_Information(2, 8) = "74296"
                Table_Information(3, 8) = "2"
                Table_Information(4, 8) = "0.00006103515625"
                Table_Information(6, 8) = "14"
                Table_Information(7, 8) = "10"
                Table_Information(8, 8) = "36"   'Step
                Table_Information(9, 8) = "-40"   'Start
                Table_Information(11, 8) = "Startup (vs. Engine Run Time) AE modifier in Gear"
                Table_Information(12, 8) = "0,4,8,12,16,20,24,28,32,36,40,44,48,52"
                Table_Information(13, 8) = "-40,-4,32,68,104,140,176,212,248,284"

                Table_Information(1, 9) = "AE Modifier vs. ECT vs. ERT - In Gear"
                Table_Information(2, 9) = "743AE"
                Table_Information(3, 9) = "2"
                Table_Information(4, 9) = "0.00006103515625"
                Table_Information(6, 9) = "14"
                Table_Information(7, 9) = "10"
                Table_Information(8, 9) = "36"   'Step
                Table_Information(9, 9) = "-40"   'Start
                Table_Information(12, 9) = "0,4,8,12,16,20,24,28,32,36,40,44,48,52"
                Table_Information(13, 9) = "-40,-4,32,68,104,140,176,212,248,284"

                Table_Information(1, 10) = "Startup AE Modifier vs. TPS"
                Table_Information(2, 10) = "743AE"
                Table_Information(3, 10) = "2"
                Table_Information(4, 10) = "0.00006103515625"
                Table_Information(6, 10) = "1"
                Table_Information(7, 10) = "11"
                Table_Information(8, 10) = "5"   'Step
                Table_Information(9, 10) = "0"   'Start
                Table_Information(11, 10) = "Additional TPS modifier for startup conditions."
                Table_Information(12, 10) = "Multiplier"
                Table_Information(13, 10) = "0,5,10,15,20,25,30,35,40,45,50"

                Table_Information(1, 11) = "Startup AE Modifier vs. AFR Correction"
                Table_Information(2, 11) = "743AE"
                Table_Information(3, 11) = "2"
                Table_Information(4, 11) = "0.00006103515625"
                Table_Information(6, 11) = "1"
                Table_Information(7, 11) = "6"
                Table_Information(8, 11) = "1"   'Step
                Table_Information(9, 11) = "0"   'Start
                Table_Information(11, 11) = "Startup AE modifier versus the startup AFR correction factor"
                Table_Information(12, 11) = "Multiplier"
                Table_Information(13, 11) = "0AFR,1AFR,2AFR,3AFR,4AFR,5AFR"

            Case 12583433

                Table_Information(1, 1) = "PE A/F vs TPS"
                Table_Information(2, 1) = "74EC8"
                Table_Information(3, 1) = "2"
                Table_Information(4, 1) = "0.0009765625"
                Table_Information(6, 1) = "1"
                Table_Information(7, 1) = "21"
                Table_Information(8, 1) = "5"
                Table_Information(9, 1) = "0"
                Table_Information(11, 1) = "This table adds to the base AFR in relation to throttle position. It is generally used to lean the fuel at smaller throttle settings."

                Table_Information(1, 2) = "Decel Enlean vs TPS"
                Table_Information(2, 2) = "756D6"
                Table_Information(3, 2) = "2"
                Table_Information(4, 2) = "0.00006103515625"
                Table_Information(6, 2) = "1"
                Table_Information(7, 2) = "21"
                Table_Information(8, 2) = "5"
                Table_Information(9, 2) = "0"
                Table_Information(11, 2) = "This is the base Enleanment Fraction vs. the maximum TPS delta seen during this enable period."

                Table_Information(1, 3) = "Decel Enlean Modifier vs Ref Counts"
                Table_Information(2, 3) = "75700"
                Table_Information(3, 3) = "2"
                Table_Information(4, 3) = "0.00006103515625"
                Table_Information(6, 3) = "1"
                Table_Information(7, 3) = "31"
                Table_Information(8, 3) = "1"
                Table_Information(9, 3) = "0"
                Table_Information(11, 3) = "Multiplier vs. Reference Counts. This is the main time profile of the DE enrichment."

                Table_Information(1, 4) = "Accel Enrichment vs Ref Counts"
                Table_Information(2, 4) = "74214"
                Table_Information(3, 4) = "2"
                Table_Information(4, 4) = "0.00006103515625"
                Table_Information(6, 4) = "1"
                Table_Information(7, 4) = "65"
                Table_Information(8, 4) = "1"
                Table_Information(9, 4) = "0"
                Table_Information(11, 4) = "Multiplier vs. Reference Counts. This is the main time profile of the AE enrichment."

        End Select

    End Function

    Public Function GetParameters(ByVal osid As Long, ByVal RT As Integer) As String

        Dim RetrieveType As Integer = RT

        Dim FlashCRC As String = ""
        Dim OSIDLoc As String = ""
        Dim YearModel As String = ""
        Dim MBTSLoc As String = ""
        Dim GFSLoc As String = ""
        Dim MAFLoc As String = ""
        Dim VELoc As String = ""
        Dim VERowCount As String = ""

        Select Case osid
            Case 9352809
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 9384050
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 9372327
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12201788
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12226107
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12223462
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12580151
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE32"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 12580150
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE32"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 12215602
                FlashCRC = "000714F0"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F240"
                VELoc = "0006F742"
                VERowCount = "15"
                YearModel = "2001"
            Case 12211473
                FlashCRC = "0007150C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F25C"
                VELoc = "0006F75E"
                VERowCount = "15"
                YearModel = "2001"
            Case 9370647
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 9357127
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12201803
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12220115
                FlashCRC = "0006FBFA"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00077AD8"
                GFSLoc = "00077838"
                MAFLoc = "0006E08C"
                VELoc = "0006E17A"
                VERowCount = "15"
                YearModel = "2000"
            Case 9355488
                FlashCRC = "0007596C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B6"
                VELoc = "00073AA4"
                VERowCount = "13"
                YearModel = "1997"
            Case 16252965
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 9372363
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 9369232
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 16257725
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12215590
                FlashCRC = "000714F0"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F240"
                VELoc = "0006F742"
                VERowCount = "15"
                YearModel = "2001"
            Case 9352682
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12218863
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 9352797
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 16243643
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 9386582
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 9371626
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12201460
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12201792
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12223458
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12223451
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12223492
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12223448
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 9372362
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12584056
                FlashCRC = "000E996E"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E7348"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 12201463
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12223463
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12202881
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12214712
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 16266449
                FlashCRC = "0007231C"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078074"
                GFSLoc = "00077DD4"
                MAFLoc = "000704BE"
                VELoc = "000705AC"
                VERowCount = "13"
                YearModel = "1998"
            Case 12583374
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F332"
                VERowCount = "15"
                YearModel = "2003"
            Case 12588931
                FlashCRC = "000E9962"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E733C"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 9378075
                FlashCRC = "00070738"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007809C"
                GFSLoc = "00077DFC"
                MAFLoc = "0006EB58"
                VELoc = ""
                VERowCount = ""
                YearModel = "1999"
            Case 9369309
                FlashCRC = "00070738"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007809C"
                GFSLoc = "00077DFC"
                MAFLoc = "0006EB58"
                VELoc = ""
                VERowCount = ""
                YearModel = "1999"
            Case 12584057
                FlashCRC = "000E996E"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E7348"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 12584058
                FlashCRC = "000E996E"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E7348"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 12588933
                FlashCRC = "000E9962"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E733C"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 12588932
                FlashCRC = "000E9962"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E733C"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 12224907
                FlashCRC = "00070ED0"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F82"
                MAFLoc = "0006EE36"
                VELoc = "0006F338"
                VERowCount = "15"
                YearModel = "2002"
            Case 12202941
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2001"
            Case 12223447
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12583373
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F332"
                VERowCount = "15"
                YearModel = "2003"
            Case 12211466
                FlashCRC = "0007150C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F25C"
                VELoc = "0006F75E"
                VERowCount = "15"
                YearModel = "2001"
            Case 9352823
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12202882
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12586824
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 9352820
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 16268296
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 16252960
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 16252961
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12585091
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12585089
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 9374960
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 9352806
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12580143
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F332"
                VERowCount = "15"
                YearModel = "2003"
            Case 12221730
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12585094
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12588500
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 9355202
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 9364943
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 16254333
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12596138
                FlashCRC = "000E9962"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E733C"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 9384500
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 9384505
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12201791
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 9389753
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 9389759
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 9393580
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 9372328
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 9384051
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 9387291
                FlashCRC = "00070F5C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEC2"
                VELoc = "0006F3C4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12201795
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 9369193
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12201470
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12204288
                FlashCRC = "0006FBFA"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00077AD8"
                GFSLoc = "00077838"
                MAFLoc = "0006E08C"
                VELoc = "0006E17A"
                VERowCount = "13"
                YearModel = "2000"
            Case 9393581
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 9365091
                FlashCRC = "0007596C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B6"
                VELoc = "00073AA4"
                VERowCount = "13"
                YearModel = "1997"
            Case 16243817
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12584938
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12584939
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12221682
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12586814
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12223456
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12596631
                FlashCRC = "000E8736"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F2C42"
                GFSLoc = "000F29A2"
                MAFLoc = "000E5C5A"
                VELoc = ""
                VERowCount = ""
                YearModel = "2005"
            Case 12583369
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F332"
                VERowCount = "15"
                YearModel = "2003"
            Case 12580139
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F332"
                VERowCount = "15"
                YearModel = "2003"
            Case 12201465
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12586825
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 9379800
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12221678
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12596136
                FlashCRC = "000E9962"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F3392"
                GFSLoc = "000F30F2"
                MAFLoc = "000E733C"
                VELoc = ""
                VERowCount = ""
                YearModel = "2004"
            Case 12223461
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 9383352
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12589761
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12224908
                FlashCRC = "00070ED0"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F82"
                MAFLoc = "0006EE36"
                VELoc = "0006F338"
                VERowCount = "15"
                YearModel = "2002"
            Case 16243648
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12578500
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12588234
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12596629
                FlashCRC = "000E8736"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F2C42"
                GFSLoc = "000F29A2"
                MAFLoc = "000E5C5A"
                VELoc = ""
                VERowCount = ""
                YearModel = "2005"
            Case 12596630
                FlashCRC = "000E8736"
                OSIDLoc = "000FFFFA"
                MBTSLoc = "000F2C42"
                GFSLoc = "000F29A2"
                MAFLoc = "000E5C5A"
                VELoc = ""
                VERowCount = ""
                YearModel = "2005"
            Case 12583433
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 12201830
                FlashCRC = "0006FBFA"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00077AD8"
                GFSLoc = "00077838"
                MAFLoc = "0006E08C"
                VELoc = "0006E17A"
                VERowCount = "13"
                YearModel = "2000"
            Case 12587799
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 9386577
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 9377388
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12581388
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 12201786
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12226105
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12590900
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 12589763
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12586823
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12586821
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 9386578
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 12201467
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 9352801
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 9377385
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12207879
                FlashCRC = "000714F0"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F240"
                VELoc = "0006F742"
                VERowCount = "15"
                YearModel = "2001"
            Case 16254467
                FlashCRC = "00075968"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B2"
                VELoc = "00073AA0"
                VERowCount = "13"
                YearModel = "1997"
            Case 9384013
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 12581471
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12201445
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 16252957
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 9365037
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12211476
                FlashCRC = "0007150C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F25C"
                VELoc = "0006F75E"
                VERowCount = "15"
                YearModel = "2001"
            Case 12223493
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 9365347
                FlashCRC = "0007596C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B6"
                VELoc = "00073AA4"
                VERowCount = "13"
                YearModel = "1997"
            Case 12201822
                FlashCRC = "0006FBFA"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00077AD8"
                GFSLoc = "00077838"
                MAFLoc = "0006E08C"
                VELoc = "0006E17A"
                VERowCount = "13"
                YearModel = "2000"
            Case 12594195
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12592070
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "2001"
            Case 12203795
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 9389750
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 9376661
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12214055
                FlashCRC = "00070786"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E44C"
                VELoc = "0006E94C"
                VERowCount = "15"
                YearModel = "2000"
            Case 12585048
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12223450
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 12211467
                FlashCRC = "0007150C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F25C"
                VELoc = "0006F75E"
                VERowCount = "15"
                YearModel = "2001"
            Case 9377739
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 16254718
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12202942
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 16259018
                FlashCRC = "0007596C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B6"
                VELoc = "00073AA4"
                VERowCount = "13"
                YearModel = "1997"
            Case 9365346
                FlashCRC = "0007596C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B6"
                VELoc = "00073AA4"
                VERowCount = "13"
                YearModel = "1997"
            Case 9355440
                FlashCRC = "0007596A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B4"
                VELoc = "00073AA2"
                VERowCount = "13"
                YearModel = "1997"
            Case 12201785
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 9355497
                FlashCRC = "0007596C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B6"
                VELoc = "00073AA4"
                VERowCount = "13"
                YearModel = "1997"
            Case 12586837
                FlashCRC = "00070F4C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "000786C0"
                GFSLoc = "00078420"
                MAFLoc = "0006EEB2"
                VELoc = "0006F3B4"
                VERowCount = "15"
                YearModel = "2002"
            Case 9377399
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12594385
                FlashCRC = "00070F8A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006EF02"
                VELoc = "0006F404"
                VERowCount = "15"
                YearModel = "2005"
            Case 12600191
                FlashCRC = "00070F8A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006EF02"
                VELoc = "0006F404"
                VERowCount = "15"
                YearModel = "2005"
            Case 12578904
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12224911
                FlashCRC = "00070ED0"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F82"
                MAFLoc = "0006EE36"
                VELoc = "0006F338"
                VERowCount = "15"
                YearModel = "2002"
            Case 12211511
                FlashCRC = "000714F0"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F240"
                VELoc = "0006F742"
                VERowCount = "15"
                YearModel = "2001"
            Case 12214057
                FlashCRC = "00070786"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E44C"
                VELoc = "0006E94C"
                VERowCount = "15"
                YearModel = "2000"
            Case 12201687
                FlashCRC = "0006FBFA"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00077AD8"
                GFSLoc = "00077838"
                MAFLoc = "0006E08C"
                VELoc = "0006E17A"
                VERowCount = "13"
                YearModel = "2000"
            Case 9387112
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2000"
            Case 9367321
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 9367747
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 9384048
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 9389716
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12201462
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12589762
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12583338
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE32"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 12583339
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE32"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 9374958
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 12586822
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12583340
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE32"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 9371627
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 16254468
                FlashCRC = "00075968"
                OSIDLoc = "0007FFF8"
                MBTSLoc = ""
                GFSLoc = "00079400"
                MAFLoc = "000739B2"
                VELoc = "00073AA0"
                VERowCount = "13"
                YearModel = "1997"
            Case 12583378
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE32"
                VELoc = "0006F334"
                VERowCount = "15"
                YearModel = "2003"
            Case 12214379
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1999"
            Case 9384046
                FlashCRC = "000706D6"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078778"
                GFSLoc = "000784D8"
                MAFLoc = "0006E39C"
                VELoc = "0006E89C"
                VERowCount = "15"
                YearModel = "2000"
            Case 9389670
                FlashCRC = "0006FBFA"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00077AD8"
                GFSLoc = "00077838"
                MAFLoc = "0006E08C"
                VELoc = "0006E17A"
                VERowCount = "13"
                YearModel = "2000"
            Case 9357128
                FlashCRC = "0007231A"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078072"
                GFSLoc = "00077DD2"
                MAFLoc = "000704BA"
                VELoc = "000705A8"
                VERowCount = "13"
                YearModel = "1998"
            Case 12585095
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 16266326
                FlashCRC = "0007231C"
                OSIDLoc = "0007FFF8"
                MBTSLoc = "00078074"
                GFSLoc = "00077DD4"
                MAFLoc = "000704BE"
                VELoc = "000705AC"
                VERowCount = "13"
                YearModel = "1998"
            Case 12583342
                FlashCRC = "00070ECE"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00078220"
                GFSLoc = "00077F80"
                MAFLoc = "0006EE30"
                VELoc = "0006F332"
                VERowCount = "15"
                YearModel = "2003"
            Case 9369395
                FlashCRC = "0006FF3A"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "00077DEA"
                GFSLoc = "00077B4A"
                MAFLoc = "0006E3CC"
                VELoc = "0006E4BA"
                VERowCount = "13"
                YearModel = "1999"
            Case 12221720
                FlashCRC = "000714E4"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F234"
                VELoc = "0006F736"
                VERowCount = "15"
                YearModel = "2001"
            Case 12201468
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12203659
                FlashCRC = "000707AC"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007884E"
                GFSLoc = "000785AE"
                MAFLoc = "0006E472"
                VELoc = "0006E972"
                VERowCount = "15"
                YearModel = "2000"
            Case 12594008
                FlashCRC = "000710C8"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007856E"
                GFSLoc = "000782CE"
                MAFLoc = "0006F016"
                VELoc = "0006F518"
                VERowCount = "15"
                YearModel = "2004"
            Case 12211462
                FlashCRC = "0007150C"
                OSIDLoc = "0007FFFA"
                MBTSLoc = "0007885A"
                GFSLoc = "000785BA"
                MAFLoc = "0006F25C"
                VELoc = "0006F75E"
                VERowCount = "15"
                YearModel = "2001"
        End Select


        Select Case RetrieveType
            Case 1
                Return FlashCRC
            Case 2
                Return OSIDLoc
            Case 3
                Return YearModel
            Case 4
                Return MBTSLoc
            Case 5
                Return GFSLoc
            Case 6
                Return MAFLoc
            Case 7
                Return VELoc
            Case 8
                Return VERowCount
        End Select

    End Function
End Module
